//CXMLResult class
//
//_path - path for save XML result file
//_xmlDoc - reference to XML document

var _XML_RESULT_PATH = "result.xml"; //path to the xml result file

function CXMLResult(path)
{
	this._path = path;
	this._xmlDoc =  new ActiveXObject("Msxml2.DOMDocument.3.0");
	this._xmlDoc.async = false;
	this._xmlDoc.resolveExternals = false;

	//init methods
	//private
	this._getFailtureTestID = xmlResult_getFailtureTestID;	
	this._getSuccessfulTestID = xmlResult_getSuccessfulTestID;
	
	//public
	this.load =  xmlResult_loadXML;
	this.alert = xmlResult_alertXML;
	this.saveFailtureTestResult = xmlResult_saveFailtureTestResult;
	this.saveSuccessfulTestResult = xmlResult_saveSuccessfulTestResult;
	this.saveStatisticTest = xmlResult_saveStatisticTest;
	this.save = xmlResult_saveDocument;
	this.getXML = xmlResult_getXML;  
	
	//init object
	if(!this.load() || this._xmlDoc.xml == "")
	{
		this._xmlDoc.loadXML('<?xml version="1.0" encoding=\'ISO-8859-1\' standalone=\'yes\' ?><?xml-stylesheet type="text/xsl" href="results.xsl"?><TestRun></TestRun>');
	}
}

//load xml document
function xmlResult_loadXML()
{
	if(this._path != "")
	{
		this._xmlDoc.load(this._path);
		return true;
	}
	else
		return false;
}

function xmlResult_alertXML()
{
	alert(this._xmlDoc.xml);
}

//save failture test result
function xmlResult_saveFailtureTestResult(tName, fType, fName, dLine, sMessage)
{
	var xmlDoc = this._xmlDoc;
		
	//get FailtureTests node
	//create FailtureTests if don't exists such section 
	var failtureTestsRoot = xmlDoc.documentElement.getElementsByTagName('FailedTests');
	if(failtureTestsRoot.length == 0)
	{
		var failtureTestsRoot = xmlDoc.createElement("FailedTests");
		xmlDoc.documentElement.appendChild(failtureTestsRoot);
		
		failtureTestsRoot = xmlDoc.documentElement.getElementsByTagName('FailedTests');
	}
	
	//create FailtureTest node	
	var failtureTestNode = xmlDoc.createElement("FailedTest");
	failtureTestsRoot[failtureTestsRoot.length - 1].appendChild(failtureTestNode);
	failtureTestNode.setAttribute("id", this._getFailtureTestID());
	
	var insertElement = xmlDoc.createElement("Name");
	insertElement.text = tName;
	failtureTestNode.appendChild(insertElement);
	
	insertElement = xmlDoc.createElement("FailureType");
	insertElement.text = fType;
	failtureTestNode.appendChild(insertElement);
	
	insertElement = xmlDoc.createElement("Location");
	failtureTestNode.appendChild(insertElement);
	
	var subDataElement = xmlDoc.createElement("File");
	subDataElement.text = fName;
	insertElement.appendChild(subDataElement);
	
	subDataElement = xmlDoc.createElement("Line");
	subDataElement.text = dLine;
	insertElement.appendChild(subDataElement);
	
	insertElement = xmlDoc.createElement("Message");
	insertElement.text = sMessage;
	failtureTestNode.appendChild(insertElement);
}

//save successful test result
function xmlResult_saveSuccessfulTestResult(tName)
{
	var xmlDoc = this._xmlDoc;
		
	//get FailtureTests node
	//create FailtureTests if don't exists such section 
	var successfulTestsRoot = xmlDoc.documentElement.getElementsByTagName('SuccessfulTests');
	if(successfulTestsRoot.length == 0)
	{
		var successfulTestsRoot = xmlDoc.createElement("SuccessfulTests");
		xmlDoc.documentElement.appendChild(successfulTestsRoot);
		
		successfulTestsRoot = xmlDoc.documentElement.getElementsByTagName('SuccessfulTests');
	}
	
	//create Test node	
	var successfulTestNode = xmlDoc.createElement("Test");
	successfulTestsRoot[successfulTestsRoot.length - 1].appendChild(successfulTestNode);
	successfulTestNode.setAttribute("id", this._getSuccessfulTestID());
	
	var insertElement = xmlDoc.createElement("Name");
	insertElement.text = tName;
	successfulTestNode.appendChild(insertElement);
}

//save statistic test
function xmlResult_saveStatisticTest()
{
	var statisticRoot = xmlDoc.documentElement.getElementsByTagName('Statistics');
	
	if(statisticRoot.length == 0)
	{
		var statisticRoot = xmlDoc.createElement("Statistics");
		xmlDoc.documentElement.appendChild(statisticRoot);
		
		statisticRoot = xmlDoc.documentElement.getElementsByTagName('Statistics');
	}
			
	//insert number of tests
	var infoTestNode = xmlDoc.createElement("Tests");
	statisticRoot[statisticRoot.length - 1].appendChild(infoTestNode);
		
	var failtureTestsNum = this._getFailtureTestID();
	var successfulTestsNum = this._getSuccessfulTestID();
	var testsNum =  parseInt(failtureTestsNum) + parseInt(successfulTestsNum);
	infoTestNode.text = testsNum;	
			
	//insert number of failture tests
	var infoTestNode = xmlDoc.createElement("FailuresTotal");
	statisticRoot[0].appendChild(infoTestNode);
	infoTestNode.text = String(failtureTestsNum);
	
	var infoTestNode = xmlDoc.createElement("Failures");
	statisticRoot[0].appendChild(infoTestNode);
	infoTestNode.text = String(failtureTestsNum);
}

//return number of failture test nodes
function xmlResult_getFailtureTestID()
{
	try
	{
		xmlDoc = this._xmlDoc;
		
		if(xmlDoc.documentElement != null)
		{
			currFailtureTestNode = xmlDoc.documentElement.selectNodes('/TestRun/FailedTests/FailedTest');
			return currFailtureTestNode.length;
		}
		else
			return 0;
	}
	catch(e) 
	{
		alert('Error in getFailtureTestID: ' + e.filename + ' ' + e.s);
	}
}

//return number of failture test nodes
function xmlResult_getSuccessfulTestID()
{
	try
	{
		xmlDoc = this._xmlDoc;
		
		if(xmlDoc.documentElement != null)
		{
			currSuccessfulTestNode = xmlDoc.documentElement.selectNodes('/TestRun/SuccessfulTests/Test');
			return currSuccessfulTestNode.length;
		}
		else
			return 0;
	}
	catch(e) 
	{
		alert('Error in getSuccessfulTestID: ' + e.filename + ' ' + e.s);
	}
}

//save XML file
//
function xmlResult_saveDocument(_path)
{
	if(_path == undefined || _path == '')
		_spath = _XML_RESULT_PATH;
	else
		_spath = _path;
 	
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	var f = fso.OpenTextFile(_spath, 2, true);

	f.Write(this._xmlDoc.xml);
	f.Close();
	
	return _spath;
}

function xmlResult_getXML()
{
	//alert(this._xmlDoc.xml);
	//var s = this._xmlDoc.xml;
	return this._xmlDoc.xml;
}


