//XML parsing functions

var _config = 'config.xml';	//XML config file

var _AUTH_ITEMS = '/Config/Authorization';
var _DOWNLOAD_ITEMS_ = '/Config/DownloadItems/Item';	//use in getMOIDAttributes, getMOIDsList
var _TEST_ITEMS_ = '/Config/TestItems/Item';	//use in getMOIDAttributes, getMOIDsList
var _PREFERENCES_ITEMS_ = '/Config/Preferences/Preference';	//use in getPreferensesList

//search value in array
//attrValue - string
//attrArray - array 
function isAttrInclude(attrValue, attrArray)
{
	var attrArrayLenght = attrArray.length;
		
	for(var i = 0; i < attrArrayLenght; i++)
		if(attrValue == attrArray[i])
			return true;
				
	return false;
}

//return hash of nodes values
//aHashKeys - array of nodes names
//attrValue - required attribute name
//xPath - required node type
//aHashKeys - array of child nodes names
function getNodeData(attrValue, xPath, aHashKeys)
{
	if (attrValue == "")
		lookFor = null;
    else
    	lookFor = attrValue;
		
	var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");
	xmlDoc.load(_config);
		 
	if (xmlDoc.parseError.errorCode != 0)
	{
		var myErr = xmlDoc.parseError;
     	alert ("Error parsing file: " + myErr.reason);
	}
	else
	{
		nodePrefs = xmlDoc.documentElement.selectNodes("/" +  xPath);
		var nodePrefsLength = nodePrefs.length;
		var rArray = new Array();						//array of node data hashes 
		 	
		for(var i = 0; i < nodePrefsLength; i++)
		{
			var Childs = nodePrefs[i].childNodes;
		 	var childCount = Childs.length;
		 				 		
		 	for(var j = 0; j < childCount; j++)
		 	{	
		 		if(attrValue != '')
		 		{
		 			//
		 			var attribute = Childs[j].getAttribute(attrValue);
		 				
		 			if(attribute != '')
		 			{
		 				var currChildNode = Childs[j].firstChild;
		 				var attrArray = new Array();
		 					
		 				while(currChildNode != null)
		 				{
		 					if(currChildNode.nodeType == 1 && isAttrInclude(currChildNode.nodeName, aHashKeys))
		 						attrArray[currChildNode.nodeName] = currChildNode.text;
		 						
		 					currChildNode = currChildNode.nextSibling;
		 				}
		 					
		 				attrArray[attrValue] = attribute;
		 				rArray.push(attrArray); 
		 			}
		 		}
		 		else
		 		{
		 			var currChildNode = Childs[j].firstChild;
		 			var attrArray = new Array();
		 			
		 			while(currChildNode != null)
		 			{
		 						 				
		 				if(currChildNode.nodeType == 1 && isAttrInclude(currChildNode.nodeName, aHashKeys))
		 				{
		 					attrArray[currChildNode.nodeName] = currChildNode.text;
		 				}
		 						 						
		 				currChildNode = currChildNode.nextSibling;
		 			}
		 			
		 			rArray[j] = attrArray;
		 		}
		 	}
		 }
		 	
		 return rArray;
		 		
	} 
		
	return false;
}

//return array of preferences names
function getPreferensesList()
{
	var rArray = new Array();
	var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");
	xmlDoc.load(_config);
	
	if (xmlDoc.parseError.errorCode != 0)
	{
		var myErr = xmlDoc.parseError;
     	alert ("Error parsing file: " + myErr.reason);
	}
	else
	{
		nodePrefs = xmlDoc.documentElement.selectNodes(_PREFERENCES_ITEMS_);
		var nodePrefsLength = nodePrefs.length;
		
		for(var i = 0; i < nodePrefsLength; i++)
			if(nodePrefs[i].nodeType == 1)
			{
				var prefName = nodePrefs[i].getAttribute('name');
				if(prefName != '')
					rArray.push(prefName); 
			}
	}
	
	return rArray;	
}

//return array of moids
//forLoad == true then use _TEST_ITEMS_
function getMOIDsList(forLoad)
{
	var getItems = (forLoad == true ? _TEST_ITEMS_ : _DOWNLOAD_ITEMS_);
		
	var rArray = new Array();
	var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");
	xmlDoc.load(_config);
	
	if (xmlDoc.parseError.errorCode != 0)
	{
		var myErr = xmlDoc.parseError;
     	alert ("Error parsing file: " + myErr.reason);
	}
	else
	{
		var nodesItems = xmlDoc.documentElement.selectNodes(getItems);
		var	nodesItemsLength = nodesItems.length;
		
		for(var i = 0; i < nodesItemsLength; i++)
		{
			var currChild = nodesItems[i].firstChild;
			while(currChild != null)
			{
				if(currChild.nodeName == 'moid')
				{
					rArray.push(currChild.text);
					break;
				}
				
				currChild = currChild.nextSibling;
			}
		}
	}
	
	return rArray;
}

//get attribute type and value in hash
//if attribute name don't exist return false
function getMOIDAttributeByName(moid, a_name)
{
	var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");
	xmlDoc.load(_config);
	
	if (xmlDoc.parseError.errorCode != 0)
	{
		var myErr = xmlDoc.parseError;
     	alert ("Error parsing file: " + myErr.reason);
	}
	else
	{
		var nodeItems = xmlDoc.documentElement.selectNodes(_DOWNLOAD_ITEMS_);
		var nodeItemsLength = nodeItems.length;
		
		for(var _i = 0; _i < nodeItemsLength; _i++)
		{
			currChildNode = nodeItems[_i].firstChild;
			
			while(currChildNode != null)
				if(currChildNode.nodeName == 'moid' && currChildNode.text == moid)
				{
					//execution part
					AttribNodes = nodeItems[_i].selectNodes('Attributes/Attribute');
					AttribNodesLength = AttribNodes.length;
					
					for(_l = 0; _l < AttribNodesLength; _l++)
					{
						if(AttribNodes[_l].getAttribute("name") == a_name)
						{
							aNode = AttribNodes[_l].firstChild;
							var rHash = new Array();
							while(aNode != null)
							{
								rHash[aNode.nodeName] = aNode.text;
								aNode = aNode.nextSibling;
							}
							
							return rHash;
						}
					}
					
					break;
						
					//return false;
				}
				else
					currChildNode = currChildNode.nextSibling;
		}	
	}	
}

//return hash of moid atributes
//name => (nodeName => nodeText)
function getMOIDAttributes(moid)
{
	var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");
	xmlDoc.load(_config);
	
	if (xmlDoc.parseError.errorCode != 0)
	{
		var myErr = xmlDoc.parseError;
     	alert ("Error parsing file: " + myErr.reason);
	}
	else
	{
		var nodePrefs = xmlDoc.documentElement.selectNodes(_DOWNLOAD_ITEMS_);
		var nodePrefsLength = nodePrefs.length;
		var rArray = new Array();
		
		for(var _i = 0; _i < nodePrefsLength; _i++)
		{
			currChildNode = nodePrefs[_i].firstChild;
			
			while(currChildNode != null)
			{
				
				//search moid 
				if(currChildNode.nodeName == 'moid' && currChildNode.text == moid)
				{
					var moidNodeAttributes = nodePrefs[_i].selectNodes('Attributes/Attribute');
					var moidAttributesLength = moidNodeAttributes.length;
					
					//get attributes					
					for(var _j = 0; _j < moidAttributesLength; _j++)
					{
						var currAttribute = moidNodeAttributes[_j].firstChild;
						var attrArray = new Array();
						
						//make attribute hash
						while(currAttribute != null)
						{
							if(currAttribute.nodeType == 1)
							{
								attrArray[currAttribute.nodeName] = currAttribute.text; 
							}
							currAttribute = currAttribute.nextSibling;
						}
						
						
						rArray[moidNodeAttributes[_j].getAttribute('name')] = attrArray;
					}
										
					break;
				}
				
				currChildNode = currChildNode.nextSibling;
			}
		}	
	}
	
	return rArray;
}

function getMOIDCharact(moid, charact)
{
	var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");
	xmlDoc.load(_config);
	
	if (xmlDoc.parseError.errorCode != 0)
	{
		var myErr = xmlDoc.parseError;
     	alert ("Error parsing file: " + myErr.reason);
	}
	else
	{
		var nodeItems = xmlDoc.documentElement.selectNodes(_DOWNLOAD_ITEMS_);
		var nodeItemsLength = nodeItems.length;
		
		for(var _i = 0; _i < nodeItemsLength; _i++)
		{
			currChildNode = nodeItems[_i].firstChild;
			
			while(currChildNode != null)
			{
				if(currChildNode.nodeName == 'moid' && currChildNode.text == moid)
				{
					charactNode = nodeItems[_i].firstChild;
					
					//get charact nodes & it values
					if(charact == undefined || charact == '')
					{
						alert('1');
						//return array of properties
						var rArray = new Array();
						
						while(charactNode != null)
						{
							rArray[charactNode.nodeName] = charactNode.text; 
							charactNode = charactNode.nextSibling;
						}
						
						return rArray;
					}
					else
					{
						while(charactNode != null)
							if(charactNode.nodeName == charact)
								return charactNode.text;
							else
								charactNode = charactNode.nextSibling;
					}			
					
					break;
				}
				else
					currChildNode = currChildNode.nextSibling;
			}
		}
	}
}

function getExpValue(nodeName, attrValue)
{
	if (attrValue == "")
		lookFor = null;
    else
    	lookFor = attrValue;
    		
    var _k = 0;
   	var takenVals = new Array();
    	
    var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");
    var nodePrefs, nodeName, i, j;
    
    xmlDoc.async = false;
    xmlDoc.load(_config);
    	
    if (xmlDoc.parseError.errorCode != 0)
    {
		var myErr = xmlDoc.parseError;
     	alert ("Error parsing file: 1" + myErr.reason);
    }
    else
    {
		nodePrefs = xmlDoc.documentElement.selectNodes("/" + nodeName);
		var nodePrefsLength = nodePrefs.length;
			
     	for (_i = 0; _i < nodePrefsLength; _i++)
     	{
     		if (nodePrefs[_i].getAttribute("name") == lookFor)
     		{
  				var vals = nodePrefs[_i].childNodes;
      			for (_j=0; _j < vals.length; _j++)
         		{
      				if (vals[_j].nodeType == 8)
      					continue;
      				takenVals[_k] = vals[_j].text;
      				_k = _k+1;
      			}
     		}
     	}
    }
    
    	
	return takenVals;
}

//return attribute for attrName node 
function getAttrValue(nodeName, attrName)
{
	var attrs = new Array();
	
	if (attrName == "")
		return attrs;
    else
    	lookFor = attrName;
    		
    var k = 0;
   	var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");
        
    xmlDoc.async = false;
    xmlDoc.load(_config);
    	
    if (xmlDoc.parseError.errorCode != 0)
    {
		var myErr = xmlDoc.parseError;
     	alert ("Error parsing file: " + myErr.reason);
    }
    else
    {
		nodePrefs = xmlDoc.documentElement.selectNodes("/" + nodeName);
			
     	for (_i=0; _i<nodePrefs.length; _i++)
     	{
     		var temp = nodePrefs[_i].getAttribute("name");
     		if(temp != '')
     			attrs.push(temp);	
     	}
    }
       	
	return attrs;
}